dnl
dnl  Author: Antonio Carzaniga <carzanig@cs.colorado.edu>
dnl
dnl  Copyright (c) 1992-2000  University of Colorado
dnl
dnl  This program is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU General Public License
dnl  as published by the Free Software Foundation; either version 2
dnl  of the License, or (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
dnl  USA, or send email to serl@cs.colorado.edu.
dnl 
dnl
dnl $Id: aclocal.m4,v 1.1.1.1 2002/06/07 21:58:46 jgiacomo Exp $
dnl

dnl  
dnl  AC_ANTO_MKPATH([ACTION-IF-NOT-FOUND][, ACTION-IF-NOT-FOUND])
dnl
dnl  check for a way to create an entire directory path 
dnl  tries `mkdir -p' and `$srcdir/mkinstalldirs'
dnl 
AC_DEFUN(AC_ANTO_MKPATH, [
  AC_CACHE_CHECK([how to create a directory path], ac_cv_anto_mkpath, [
    anto_td=_test_anto
    # paranoia...
    while test -r $anto_td; do anto_td="$anto_td."; done
    ac_cv_anto_mkpath=no
    if mkdir -p $anto_td/1/2 > /dev/null 2>&1 && test -d $anto_td/1/2; then
      /bin/rm -rf $anto_td
      ac_cv_anto_mkpath="mkdir -p"
    elif $srcdir/mkinstalldirs $anto_td/1/2 > /dev/null 2>&1 && test -d $anto_td/1/2; then
      ac_cv_anto_mkpath=\$\(srcdir\)/mkinstalldirs
    else
      ac_cv_anto_mkpath=no
    fi])
  if test "$ac_cv_anto_mkpath" = no; then
    MKPATH=""
    : 
    $1
  else
    MKPATH="$ac_cv_anto_mkpath"
    AC_SUBST(MKPATH)
    :
    $2
  fi])

AC_DEFUN(AC_ANTO_JAVAC, [
  AC_PATH_PROGS(JAVAC, javac)
  test -z "$JAVAC" && AC_MSG_ERROR([
No acceptable Java compiler found in \$PATH
You may specify a Java compiler by setting the env variable JAVAC
or you might use --with-javabin to specify the java binary directory
])
  AC_CACHE_CHECK([whether $JAVAC works], ac_cv_anto_javac_works, [
    anto_java_test=T
    # paranoia
    while test -r $anto_java_test.java || test -r $anto_java_test.class; do
      anto_java_test=${anto_java_test}T
    done
    cat > $anto_java_test.java << EOF
import java.util.TreeMap;
import java.net.Socket;
import java.io.IOException;
public class $anto_java_test {
    public TreeMap x = new TreeMap();
    public Socket s;
    void testing() throws IOException {
        Socket s = new Socket("localhost",1234);
        s.shutdownOutput();
        s.shutdownInput();
    }
}
EOF
    if AC_TRY_COMMAND($JAVAC $anto_java_test.java); then 
       ac_cv_anto_javac_works=yes
    else 
       ac_cv_anto_javac_works=no
    fi
    rm -f $anto_java_test.java $anto_java_test.class
  ])
  test $ac_cv_anto_javac_works = no && AC_MSG_ERROR([
The Java compiler $JAVAC failed. (see config.log)
You need JDK version 1.3 to compile and run Siena
])
])
dnl
AC_DEFUN(AC_ANTO_JAVA_CLASS, [
if test -z "$2"
then
	anto_jclass_msg="checking for class $1"
	anto_jclass_err="could not find class $1"
else
	anto_jclass_msg="checking for $2"
	anto_jclass_err="could not find $2"
fi
AC_MSG_CHECKING([$anto_jclass_msg])
anto_jclass=Jclass
while test -f $anto_jclass.java -o -f $anto_jclass.class; do
	anto_jclass=J$anto_jclass
done
cat > $anto_jclass.java <<EOF
	public class $anto_jclass {
		public static $1 XXX;
        }
EOF
if test -z "$CLASSPATH"; 
then
	anto_jclass_classpath=''
else
	anto_jclass_classpath="-classpath $CLASSPATH"
fi
if AC_TRY_COMMAND($JAVAC $anto_jclass_classpath $anto_jclass.java) ; then 
	anto_jclass_result=yes
else
	anto_jclass_result=no
fi
rm -f $anto_jclass.java $anto_jclass.class
case "$anto_jclass_result" in
	yes)
	AC_MSG_RESULT(yes)
	;;
	no)
	AC_MSG_RESULT(no)
	AC_MSG_ERROR([$anto_jclass_err
You may need to adjust your CLASSPATH.
You can assign a CLASSPATH with the --with-classpath option,
or you can set the CLASSPATH environment variable.])
	;;
esac
])
