//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: Observer.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
/* Generated by Together */

package siena.xml;

/** Observer interface for use with the XMLSubscriptionHandler object
 */
public interface Observer {
    /** This method is used to update the observer that is watching the XMLSubscriptionHandler.
     * It is only called when an XML Notification has met the XPath requirements given to the XMLSubscriptionHandler
     * by the observer.
     * @param handler The XMLSubscriptionHandler object that contains the matching XML notification.
     */    
    void update(XMLSubscriptionHandler handler);

    /**
     * @link
     * @shapeType PatternLink
     * @pattern Observer
     * @supplierRole Concrete observers 
     */
    /*# private XMLClient _xmlClient; */

    /**
     * @link
     * @shapeType PatternLink
     * @pattern Observer
     * @clientRole Observer
     * @supplierRole <{Subject}>
     */
    /*# private Subject _subject; */
}
