//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: RulesParser.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
// $ANTLR 2.7.1: "rules.g" -> "RulesParser.java"$
package siena.xml.rules;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


import java.io.*;
import java.util.Vector;


/** Generated by ANTLR
 */
public class RulesParser extends antlr.LLkParser
       implements RulesParserTokenTypes
 {

protected RulesParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public RulesParser(TokenBuffer tokenBuf) {
  this(tokenBuf,4);
}

protected RulesParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public RulesParser(TokenStream lexer) {
  this(lexer,4);
}

public RulesParser(ParserSharedInputState state) {
  super(state,4);
  tokenNames = _tokenNames;
}

	public final java.util.HashMap  program() throws RecognitionException, TokenStreamException {
		java.util.HashMap map;
		
		Rule r = null; map = new java.util.HashMap();
		
		try {      // for error handling
			{
			_loop3:
			do {
				if ((LA(1)==TK_rule)) {
					r=rule();
					
					Object temp = map.get(r.getTargetTag());
					if (temp != null) {
					((Vector)temp).addElement(r);
					} else {
					Vector v = new Vector();
					v.addElement(r);
					map.put(r.getTargetTag(), v);
					}
					
				}
				else {
					break _loop3;
				}
				
			} while (true);
			}
			match(Token.EOF_TYPE);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		return map;
	}
	
	public final Rule  rule() throws RecognitionException, TokenStreamException {
		Rule rule;
		
		rule = null; String targetString = null; String actionString = null; Vector conditions = new Vector();
		
		try {      // for error handling
			match(TK_rule);
			match(COLON);
			targetString=target();
			conditions=conditions();
			actionString=action();
			rule = new Rule(targetString ,actionString); 
			int i = 0;
			if (conditions.size() > 1) {
			String type = (String)conditions.elementAt(0);
			if (type.equals("and")) {
			rule.setToAndRule();
			} else {
			rule.setToOrRule();
			}
			i++;
			Vector attributes = new Vector();
			for (; i < conditions.size(); i+=2) {
			attributes.addElement(conditions.elementAt(i));
			Condition c = (Condition)conditions.elementAt(i+1);
			rule.addCondition(c);
			}
			rule.setAttributeTargets(attributes);
			} else {    
			Condition c = (Condition)conditions.elementAt(i);
			rule.addCondition(c);
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return rule;
	}
	
	public final String  target() throws RecognitionException, TokenStreamException {
		String target;
		
		Token  attr = null;
		Token  str = null;
		target = null; String tagString = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case ID:
			{
				{
				tagString=tag();
				{
				switch ( LA(1)) {
				case ATTRIBUTE:
				{
					attr = LT(1);
					match(ATTRIBUTE);
					break;
				}
				case TK_group:
				case TK_ignore:
				case TK_unique:
				case TK_path:
				case TK_and:
				case TK_or:
				case TK_present:
				case TK_notpresent:
				case TK_notunique:
				case TK_novalue:
				case NOT:
				case RCURLY:
				case LESS:
				case GREATER:
				case EQUAL:
				case COMA:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				}
				if (attr != null) {
				target = new String(tagString+attr.getText());
				} else {
				target = tagString; 
				}
				
				break;
			}
			case STRING_LITERAL:
			{
				str = LT(1);
				match(STRING_LITERAL);
				target = str.getText(); 
				target = target.replace('\"',' ').trim();
				
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		return target;
	}
	
	public final Vector  conditions() throws RecognitionException, TokenStreamException {
		Vector conditions;
		
		Token  attr1 = null;
		Token  attr2 = null;
		conditions = new Vector(); Condition c = null; String compoundType = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TK_present:
			case TK_notpresent:
			case NOT:
			case LESS:
			case GREATER:
			case EQUAL:
			{
				c=expr();
				conditions.addElement(c);
				break;
			}
			case TK_and:
			case TK_or:
			{
				compoundType=compound();
				conditions.addElement(compoundType);
				match(LCURLY);
				attr1 = LT(1);
				match(ATTRIBUTE);
				c=expr();
				conditions.addElement(attr1.getText()); conditions.addElement(c);
				{
				_loop14:
				do {
					if ((LA(1)==COMA)) {
						match(COMA);
						attr2 = LT(1);
						match(ATTRIBUTE);
						c=expr();
						conditions.addElement(attr2.getText()); conditions.addElement(c);
					}
					else {
						break _loop14;
					}
					
				} while (true);
				}
				match(RCURLY);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
		return conditions;
	}
	
	public final String  action() throws RecognitionException, TokenStreamException {
		String action;
		
		Token  id = null;
		action = null; String axis = null; String tagString = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TK_group:
			{
				match(TK_group);
				match(COLON);
				id = LT(1);
				match(ID);
				action = new String("group:"+id.getText());
				break;
			}
			case TK_unique:
			{
				match(TK_unique);
				match(COLON);
				{
				switch ( LA(1)) {
				case ID:
				{
					tagString=tag();
					break;
				}
				case TK_sibling:
				case TK_child:
				case TK_parent:
				{
					axis=treeAxis();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				if (tagString != null) 
				action = new String("unique:"+tagString); 
				else 
				action = new String("unique:"+axis);
				
				break;
			}
			case TK_notunique:
			{
				match(TK_notunique);
				action = "notunique";
				break;
			}
			case TK_path:
			{
				match(TK_path);
				action = "path";
				break;
			}
			case TK_ignore:
			{
				match(TK_ignore);
				action = "ignore";
				break;
			}
			case TK_novalue:
			{
				match(TK_novalue);
				action = "novalue";
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return action;
	}
	
	public final String  tag() throws RecognitionException, TokenStreamException {
		String tag;
		
		Token  id = null;
		StringBuffer tagPath = new StringBuffer(); String temp = null; tag=null;
		
		try {      // for error handling
			{
			_loop10:
			do {
				if ((LA(1)==ID) && (LA(2)==SLASH)) {
					temp=path();
					tagPath.append(temp);
				}
				else {
					break _loop10;
				}
				
			} while (true);
			}
			id = LT(1);
			match(ID);
			tag = new String(tagPath.toString()+id.getText());
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_4);
		}
		return tag;
	}
	
	public final String  path() throws RecognitionException, TokenStreamException {
		String path;
		
		Token  id = null;
		path = null;
		
		try {      // for error handling
			id = LT(1);
			match(ID);
			match(SLASH);
			path = new String(id.getText()+"/");
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
		return path;
	}
	
	public final Condition  expr() throws RecognitionException, TokenStreamException {
		Condition c;
		
		c = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case EQUAL:
			{
				c=assignExpr();
				break;
			}
			case NOT:
			{
				c=notequalExpr();
				break;
			}
			case TK_present:
			{
				presentExpr();
				c = new ExistsCondition(true);
				break;
			}
			case TK_notpresent:
			{
				notpresentExpr();
				c = new ExistsCondition(false);
				break;
			}
			case LESS:
			{
				c=lessThanExpr();
				break;
			}
			case GREATER:
			{
				c=greaterThanExpr();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return c;
	}
	
	public final String  compound() throws RecognitionException, TokenStreamException {
		String type;
		
		Token  id = null;
		Token  id2 = null;
		type = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TK_and:
			{
				id = LT(1);
				match(TK_and);
				type = id.getText();
				break;
			}
			case TK_or:
			{
				id2 = LT(1);
				match(TK_or);
				type = id2.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_7);
		}
		return type;
	}
	
	public final String  treeAxis() throws RecognitionException, TokenStreamException {
		String sib;;
		
		sib = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TK_sibling:
			{
				match(TK_sibling);
				sib = "sibling";
				break;
			}
			case TK_child:
			{
				match(TK_child);
				sib = "child";
				break;
			}
			case TK_parent:
			{
				match(TK_parent);
				sib = "parent";
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return sib;
	}
	
	public final String  exprTarget() throws RecognitionException, TokenStreamException {
		String target;
		
		target = null; String targetString = null; String axis = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case TK_sibling:
			case TK_child:
			case TK_parent:
			{
				axis=treeAxis();
				break;
			}
			case STRING_LITERAL:
			case ID:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			targetString=target();
			if (axis != null)
			target = new String(axis+" "+targetString);
			else
			target = targetString;
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return target;
	}
	
	public final Condition  assignExpr() throws RecognitionException, TokenStreamException {
		Condition condition;
		
		Token  myInt = null;
		Token  myint1 = null;
		Token  myint2 = null;
		condition = null; String target = null;
		
		try {      // for error handling
			if ((LA(1)==EQUAL) && (_tokenSet_9.member(LA(2))) && (_tokenSet_10.member(LA(3)))) {
				match(EQUAL);
				{
				switch ( LA(1)) {
				case TK_sibling:
				case TK_child:
				case TK_parent:
				case STRING_LITERAL:
				case ID:
				{
					target=exprTarget();
					break;
				}
				case INT:
				{
					myInt = LT(1);
					match(INT);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				if (myInt != null) {
					    	condition = new EqualityCondition(Integer.parseInt(myInt.getText()), true);
				} else {
					    	condition = new EqualityCondition(target, true);
					        }
				
			}
			else if ((LA(1)==EQUAL) && (LA(2)==INT) && (LA(3)==DOT)) {
				match(EQUAL);
				myint1 = LT(1);
				match(INT);
				match(DOT);
				myint2 = LT(1);
				match(INT);
				
				String number = myint1.getText()+"."+myint2.getText();
				condition = new EqualityCondition(Double.parseDouble(number), true);
				
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return condition;
	}
	
	public final Condition  notequalExpr() throws RecognitionException, TokenStreamException {
		Condition condition;
		
		Token  myInt = null;
		Token  myint1 = null;
		Token  myint2 = null;
		String neExpr = null; condition = null;
		
		try {      // for error handling
			if ((LA(1)==NOT) && (LA(2)==EQUAL) && (_tokenSet_9.member(LA(3))) && (_tokenSet_10.member(LA(4)))) {
				match(NOT);
				match(EQUAL);
				{
				switch ( LA(1)) {
				case TK_sibling:
				case TK_child:
				case TK_parent:
				case STRING_LITERAL:
				case ID:
				{
					neExpr=exprTarget();
					break;
				}
				case INT:
				{
					myInt = LT(1);
					match(INT);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				
				if (myInt != null) {
					    	condition = new EqualityCondition(Integer.parseInt(myInt.getText()), false);
				} else {
					    	condition = new EqualityCondition(neExpr, false);
					        }
				
			}
			else if ((LA(1)==NOT) && (LA(2)==EQUAL) && (LA(3)==INT) && (LA(4)==DOT)) {
				match(NOT);
				match(EQUAL);
				myint1 = LT(1);
				match(INT);
				match(DOT);
				myint2 = LT(1);
				match(INT);
				
				String number = myint1.getText()+"."+myint2.getText();
				condition = new EqualityCondition(Double.parseDouble(number), false);
				
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return condition;
	}
	
	public final void presentExpr() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			match(TK_present);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
	}
	
	public final void notpresentExpr() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			match(TK_notpresent);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
	}
	
	public final Condition  lessThanExpr() throws RecognitionException, TokenStreamException {
		Condition condition;
		
		Token  myInt = null;
		Token  myInt1 = null;
		Token  myInt2 = null;
		condition = null;
		
		try {      // for error handling
			if ((LA(1)==LESS) && (LA(2)==INT) && (_tokenSet_6.member(LA(3)))) {
				match(LESS);
				myInt = LT(1);
				match(INT);
				condition = new InequalityCondition(Integer.parseInt(myInt.getText()), true);
			}
			else if ((LA(1)==LESS) && (LA(2)==INT) && (LA(3)==DOT)) {
				match(LESS);
				myInt1 = LT(1);
				match(INT);
				match(DOT);
				myInt2 = LT(1);
				match(INT);
				
				String number = myInt1.getText()+"."+myInt2.getText();
				condition = new InequalityCondition(Double.parseDouble(number), true);
				
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return condition;
	}
	
	public final Condition  greaterThanExpr() throws RecognitionException, TokenStreamException {
		Condition condition;
		
		Token  myInt = null;
		Token  myInt1 = null;
		Token  myInt2 = null;
		condition = null;
		
		try {      // for error handling
			if ((LA(1)==GREATER) && (LA(2)==INT) && (_tokenSet_6.member(LA(3)))) {
				match(GREATER);
				myInt = LT(1);
				match(INT);
				condition = new InequalityCondition(Integer.parseInt(myInt.getText()), false);
			}
			else if ((LA(1)==GREATER) && (LA(2)==INT) && (LA(3)==DOT)) {
				match(GREATER);
				myInt1 = LT(1);
				match(INT);
				match(DOT);
				myInt2 = LT(1);
				match(INT);
				
				String number = myInt1.getText()+"."+myInt2.getText();
				condition = new InequalityCondition(Double.parseDouble(number), false);
				
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return condition;
	}
	
	public final String  atom() throws RecognitionException, TokenStreamException {
		String atom;
		
		Token  id = null;
		Token  theInt = null;
		Token  theChar = null;
		Token  theString = null;
		atom = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case ID:
			{
				id = LT(1);
				match(ID);
				atom = id.getText();
				break;
			}
			case INT:
			{
				theInt = LT(1);
				match(INT);
				atom = theInt.getText();
				break;
			}
			case CHAR_LITERAL:
			{
				theChar = LT(1);
				match(CHAR_LITERAL);
				atom = theChar.getText();
				break;
			}
			case STRING_LITERAL:
			{
				theString = LT(1);
				match(STRING_LITERAL);
				atom = theString.getText();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		return atom;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"rule\"",
		"\"group\"",
		"\"ignore\"",
		"\"unique\"",
		"\"path\"",
		"\"and\"",
		"\"or\"",
		"\"present\"",
		"\"notpresent\"",
		"\"notunique\"",
		"\"sibling\"",
		"\"child\"",
		"\"parent\"",
		"\"novalue\"",
		"WS",
		"SL_COMMENT",
		"NOT",
		"LCURLY",
		"RCURLY",
		"LESS",
		"GREATER",
		"EQUAL",
		"COLON",
		"COMA",
		"SLASH",
		"CHAR_LITERAL",
		"STRING_LITERAL",
		"ESC",
		"DIGIT",
		"DOT",
		"INT",
		"an identifier",
		"ATTRIBUTE"
	};
	
	private static final long _tokenSet_0_data_[] = { 2L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 18L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { 198328288L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long _tokenSet_3_data_[] = { 139744L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	private static final long _tokenSet_4_data_[] = { 68917805042L, 0L };
	public static final BitSet _tokenSet_4 = new BitSet(_tokenSet_4_data_);
	private static final long _tokenSet_5_data_[] = { 34359738368L, 0L };
	public static final BitSet _tokenSet_5 = new BitSet(_tokenSet_5_data_);
	private static final long _tokenSet_6_data_[] = { 138551776L, 0L };
	public static final BitSet _tokenSet_6 = new BitSet(_tokenSet_6_data_);
	private static final long _tokenSet_7_data_[] = { 2097152L, 0L };
	public static final BitSet _tokenSet_7 = new BitSet(_tokenSet_7_data_);
	private static final long _tokenSet_8_data_[] = { 35433480210L, 0L };
	public static final BitSet _tokenSet_8 = new BitSet(_tokenSet_8_data_);
	private static final long _tokenSet_9_data_[] = { 52613464064L, 0L };
	public static final BitSet _tokenSet_9 = new BitSet(_tokenSet_9_data_);
	private static final long _tokenSet_10_data_[] = { 104559944160L, 0L };
	public static final BitSet _tokenSet_10 = new BitSet(_tokenSet_10_data_);
	
	}
