//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: ComparisonPredicateTest.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//

/*
 * ComparisonPredicateTest.java
 * JUnit based test
 *
 * Created on December 2, 2001, 9:30 PM
 */                

package siena.xml.tests;

import junit.framework.*;

/**
 *
 * @author unknown
 */                                
public class ComparisonPredicateTest extends TestCase {
    
    public ComparisonPredicateTest(java.lang.String testName) {
        super(testName);
    }        
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(ComparisonPredicateTest.class);
        
        return suite;
    }
    
    /** Test of getStringArg method, of class siena.xml.xpath.ComparisonPredicate. */
    public void testGetStringArg() {
        siena.xml.xpath.ComparisonPredicate predicate = new siena.xml.xpath.ComparisonPredicate("test > 1");
        System.out.println(" - Test: ComparisonPredicate - getStringArg method.");
        
        Assert.assertEquals("ComparisonPredicate did not create the correct string arguement.", "test", predicate.getStringArg());
    }
    
    /** Test of getIntegerArg method, of class siena.xml.xpath.ComparisonPredicate. */
    public void testGetIntegerArg() {
        siena.xml.xpath.ComparisonPredicate predicate = new siena.xml.xpath.ComparisonPredicate("test > 1");

        System.out.println(" - Test: ComparisionPredicate - getIntegerArg method.");
        Assert.assertEquals("ComparisonPredicate did not create the correct string arguement.", 1, predicate.getIntegerArg());
    }
    
    /** Test of getDoubleArg method, of class siena.xml.xpath.ComparisonPredicate. */
    public void testGetDoubleArg() {
        siena.xml.xpath.ComparisonPredicate predicate = new siena.xml.xpath.ComparisonPredicate("test > 0.1");
        System.out.println(" - Test: ComparisionPredicate - getDoubleArg method.");
        
        Assert.assertEquals("ComparisonPredicate did not create the correct string arguement.", 0.1, predicate.getDoubleArg(), (1.0-predicate.getDoubleArg()));
    }
    
    /** Test of getOp method, of class siena.xml.xpath.ComparisonPredicate. */
    public void testGetOp() {
        siena.xml.xpath.ComparisonPredicate predicate = new siena.xml.xpath.ComparisonPredicate("test > 1");
        System.out.println(" - Test: ComparisonPredicate - getOp method.");
        Assert.assertEquals("ComparisonPredicate did not create the correct string arguement.", ">", predicate.getOp());
    }
    
    /** Test of isThereAnIntegerArg method, of class siena.xml.xpath.ComparisonPredicate. */
    public void testIsThereAnIntegerArg() {
        siena.xml.xpath.ComparisonPredicate predicate = new siena.xml.xpath.ComparisonPredicate("test > 1");
        System.out.println(" - Test: ComparisonPredicate - isThereAnIntegerArg method");

        Assert.assertTrue("ComparisonPredicate did not create the correct string arguement.", predicate.isThereAnIntegerArg());
        predicate = new siena.xml.xpath.ComparisonPredicate("test > .01");
        Assert.assertTrue("ComparisonPredicate did not create the correct string arguement.", !predicate.isThereAnIntegerArg());        
    }    
}
