//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: XPathTest.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//

/*
 * XPathTest.java
 * JUnit based test
 *
 * Created on December 2, 2001, 9:30 PM
 */                

package siena.xml.tests;

import siena.xml.xpath.XPath;
import siena.xml.xpath.Step;
import junit.framework.*;


/**
 *
 * @author unknown
 */                                
public class XPathTest extends TestCase {
    
    public XPathTest(java.lang.String testName) {
        super(testName);
    }        
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(XPathTest.class);
        
        return suite;
    }
    
    /** Test of getStepAt method, of class siena.xml.xpath.XPath. */
    public void testGetStepAt() {
        XPath path = null;
        Step step = null;

        System.out.println(" - Test: XPath - getStepAt method.");
        
        path = new XPath("step0/step1[substring(name, bob)]/step2[3]");
        step = path.getStepAt(0);
        assertEquals("The wrong step was returned for step 0.","step0", step.getNodeTest());
        step = path.getStepAt(1);
        assertEquals("The wrong step was returned for step 1.","step1", step.getNodeTest());
        step = path.getStepAt(2);
        assertEquals("The wrong step was returned for step 2.","step2", step.getNodeTest());
    }
    
    /** Test of getNumberOfSteps method, of class siena.xml.xpath.XPath. */
    public void testGetNumberOfSteps() {
        XPath path = null;

        System.out.println(" - Test: XPath - getNumberOfSteps method.");

        path = new XPath("/");
        assertEquals("No steps given but the XPath thought there were some steps.", 0, path.getNumberOfSteps());
        path = new XPath("/step1");
        assertEquals("Wrong number of steps returned.", 1, path.getNumberOfSteps());
        path = new XPath("/step1/step2/3/4/5");
        assertEquals("Wrong number of steps returned.", 5, path.getNumberOfSteps());        
    }
    
    /** Test of toString method, of class siena.xml.xpath.XPath. */
    public void testToString() {
        XPath path = null;

        System.out.println(" - Test: XPath - getStepAt method.");
        
        path = new XPath("/test1/test2/test2/passed [ failed = false ]");        
        assertEquals("The XPath given and the XPath recieved were different.", "/test1/test2/test2/passed [ failed = false ]", path.toString());
    }
}
