//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: XSchemaProcessorTest.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//

/*
 * XSchemaProcessorTest.java
 * JUnit based test
 *
 * Created on December 2, 2001, 9:27 PM
 */                

package siena.xml.tests;

import junit.framework.*;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.NamedNodeMap;
import java.util.Vector;
import java.util.HashMap;
import java.io.FileInputStream;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import java.io.IOException;
import siena.xml.rules.Rule;
import siena.xml.rules.RulesGenerator;
import siena.xml.XSchemaProcessor;

/**
 * @author Chris Corliss
 */                                
public class XSchemaProcessorTest extends TestCase {
    
    public XSchemaProcessorTest(String testName) {
        super(testName);
    }        
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        return ( new TestSuite(XSchemaProcessorTest.class));        
    }
    
    /** Test of getXMLRules method, of class siena.xml.XSchemaProcessor. */
    public void testGetXMLRules() {
        XSchemaProcessor processor = new XSchemaProcessor();
        java.io.StringWriter writer = null;
        java.io.PrintWriter printWriter = null;

        System.out.println(" - Test: XSchemaProcessor - getXMLRules method");

        try {
            processor.setXSchema(this.getClass().getResource("test.xsd").getFile());
        } catch (Exception exception) {
            writer = new java.io.StringWriter();
            printWriter = new java.io.PrintWriter(writer);
            writer.write("Exception caught during test run: ");
            writer.write("\n\n*******BEGIN EXCEPTION********\n\n");
            exception.printStackTrace(printWriter);
            writer.write("\n*******END EXCEPTION********\n");
            fail(writer.toString());
        }

        java.util.HashMap rules = processor.getXMLRules();
        
        Assert.assertNotNull("XML rules returned were null.",rules);
        Assert.assertTrue("No XML rules were returned.", !(rules.isEmpty()));
    }
}
