//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: EqualityPredicate.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
/* Generated by Together */

package siena.xml.xpath;

/** Object representing a equality predicate. This object can handle string comparisons,
 * integer, or double value comparisons.
 */
public class EqualityPredicate extends Predicate {
    
    private String target;
    private long integerValue;
    private double doubleValue;
    private String value;
    private boolean isIntegerComparison = false;
    private boolean isDoubleComparison = false;
    private boolean isStringComparison = true;

    public EqualityPredicate (String target, String theValue) {
        super(Predicate.EQUALITY);
        String value = theValue.replace('\"',' ').trim();
        this.target = target;
        this.value = value;
        try {
            integerValue = Integer.parseInt(value);
            isIntegerComparison = true;
            isStringComparison = false;
            return;
        } catch (Exception ignore) {}
        try {
            doubleValue = Double.parseDouble(value);
            isDoubleComparison = true;
            isStringComparison = false;            
            return;
        } catch (Exception ignore) {}
    }
    
    public String getStringValue() {
        return value;
    }

    public long getIntValue() {
        return integerValue;
    }

    public double getDoubleValue() {
        return doubleValue;
    }

    public boolean isIntegerComparison() {
        return isIntegerComparison;
    }

    public boolean isDoubleComparison() {
        return isDoubleComparison;
    }

    public boolean isStringComparison() {
        return isStringComparison;
    }

    public String getTarget() {
        return target;
    }
}
