//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: PredicateGenerator.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
package siena.xml.xpath; 

/*
 * PredicateGenerator.java
 *
 * Created on January 28, 2002, 3:25 PM
 */
import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


import java.io.*;
import java.util.Vector;
/** This class generates a binary tree based for a compound predciate.
 *
 * @author CorliC
 */
class PredicateGenerator {
    private PredicateParser parser;
    java.util.HashMap map;

    public PredicateGenerator(InputStream is) {
        PredicateLexer lexer = new PredicateLexer(is);
        parser = new PredicateParser(lexer);
        try {
            parser.predicate();
        } catch (Exception e) {
            System.err.println("exception: "+e);
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        try {
            DataInputStream dis = new DataInputStream(System.in);
            PredicateGenerator m = new PredicateGenerator(dis);
        } catch(Exception e) {
            System.err.println("exception: "+e);
            e.printStackTrace();
        }
    }
}
