//
//  This file is part of SienaXML, an XML interface to the 
//  Siena wide-area event notification system.
//  See http://www.cs.colorado.edu/serl/siena/
//
//  Author: Chris Corliss <corliss@falcon.stortek.com>
//  See the file AUTHORS for full details. 
//
//  Copyright (C) 2001-2002 University of Colorado
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2.1 of the License, or (at your option) any later version.
//  
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//  
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
//
// $Id: XPath.java,v 1.1.1.1 2002/06/07 22:42:37 jgiacomo Exp $
//
/* Generated by Together */

package siena.xml.xpath;

import java.util.Vector;
import java.util.StringTokenizer;

/** This object represents a complete XPath statement made of multiple Steps.
 */
public class XPath {

    /**
     * This variable holds the individual steps in the XPath statement.
     */
    
    private Vector steps;
    /** This variable holds the XML path as a string.
     */    
    private String pathText;

    /** This is the constructor.
     * @stereotype constructor
     * @param path XPath in string format to use to build the XPath object.
     */

    public XPath(String path) {
        StringTokenizer tokens = new StringTokenizer(path,"/");
        pathText = path;
        steps = new Vector();
        while(tokens.hasMoreTokens()) {
            steps.addElement(new Step(tokens.nextToken()));
        }
    }

    public Step getStepAt(int index) {
        return (Step)steps.elementAt(index);
    }

    public int getNumberOfSteps() {
        return steps.size();
    }
    
    public String toString() {
        return pathText;
    }
}
